package de.pincservices.pdf.renderer;

import de.pincservices.pdf.Renderer;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Collections;
import java.util.List;

public abstract class AbstractRenderer implements Renderer {

    @Override
    public void createFromContent(String content, String destinationFilename, String externalResourcesBaseUrl) {
        createFromContent(Collections.singletonList(content), destinationFilename, externalResourcesBaseUrl);
    }

    @Override
    public void createFromContent(List<String> pages, String destinationFilename, String externalResourcesBaseUrl) {
        OutputStream os = null;
        try {
            os = new FileOutputStream(destinationFilename);
            createFromContent(pages, os, externalResourcesBaseUrl);
            os.close();
            os = null;
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (os != null) {
                try {
                    os.close();
                } catch (IOException e) {
                    // ignore
                }
            }
        }
    }
}
