package de.pincservices.pdf.renderer;

import com.itextpdf.text.Document;
import com.itextpdf.text.Element;
import com.itextpdf.text.html.simpleparser.HTMLWorker;
import com.itextpdf.text.html.simpleparser.StyleSheet;
import com.itextpdf.text.pdf.PdfWriter;

import java.io.OutputStream;
import java.io.StringReader;
import java.util.Iterator;
import java.util.List;

public class ITextPdfRenderer extends AbstractRenderer {

    @Override
    @SuppressWarnings("unchecked")
    public void createFromContent(List<String> pages, OutputStream outputStream, String externalResourcesBaseUrl) {
        try {

            final Iterator<String> iterator = pages.iterator();
            final Document document = new Document();
            PdfWriter.getInstance(document, outputStream);
            document.open();
            final StyleSheet styleSheet = new StyleSheet();

            while (iterator.hasNext()) {
                List<Element> objects = HTMLWorker.parseToList(new StringReader(iterator.next()), styleSheet);
                for (Element element : objects) {
                    document.add(element);
                }
                document.newPage();
            }

            document.close();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
