package de.pincservices.template;

import java.util.List;

public abstract class AbstractTemplateEngine implements TemplateEngine {

    private static final String DEFAULT_TEMPLATE_LOCATION = "xml";

    private String _templateLocation;

    protected AbstractTemplateEngine(String templateLocation) {
        _templateLocation = templateLocation != null ? templateLocation : DEFAULT_TEMPLATE_LOCATION;
    }

    public abstract void initConfiguration(List<TemplateDirective> templateDirectives) throws Exception;

    protected String getTemplateLocation() {
        return _templateLocation;
    }

    protected String getTemplateName() {
        return "dummyTemplate";
    }
}
