package de.pincservices.template;

import de.pincservices.pdf.PdfRendererTest;
import de.pincservices.template.velocity.AbstractVelocityTemplateDirective;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.parser.node.Node;

import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;

public class CustomMacroDirective extends AbstractVelocityTemplateDirective {

    public CustomMacroDirective() {
        super("customMacro");
    }

    @Override
    public int getType() {
        return LINE;
    }

    @Override
    public boolean render(InternalContextAdapter context, Writer writer, Node node) throws IOException, ResourceNotFoundException, ParseErrorException, MethodInvocationException {
        final Object o = node.jjtGetChild(0).value(context);
        if (o != null) {
            if (o instanceof PdfRendererTest.User) {
                final PdfRendererTest.User user = (PdfRendererTest.User) o;
                final SimpleDateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy");
                writer.write("<i>" + dateFormat.format(user.getBirthDate()) + "</i>");
            } else {
                node.jjtGetChild(0).render(context, writer);
            }
        }
        return true;
    }

    @Override
    public Class getVariableClass() {
        return getClass();
    }
}
