package de.pincservices.template;

import de.pincservices.template.velocity.AbstractVelocityTemplateDirective;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.parser.node.Node;

import java.io.IOException;
import java.io.Writer;
import java.util.Collection;

public class EmailPrefixVelocityTemplateDirective extends AbstractVelocityTemplateDirective {

    public EmailPrefixVelocityTemplateDirective() {
        super("emailPrefix");
    }

    @Override
    public Class getVariableClass() {
        return getClass();
    }

    @Override
    public int getType() {
        return LINE;
    }

    @Override
    public boolean render(InternalContextAdapter internalContextAdapter, Writer writer, Node node) throws IOException, ResourceNotFoundException, ParseErrorException, MethodInvocationException {
        final Object o = node.jjtGetChild(0).value(internalContextAdapter);
		if (o != null) {
			if (o instanceof String) {
                writer.write("email: " + o);
			} else if (o instanceof Collection) {
				for (String item : (Collection<String>) o) {
                    writer.write("email: " + item + "<br />\n");
				}
			} else {
				node.jjtGetChild(0).render(internalContextAdapter, writer);
			}
		}
		return true;
	}
}
