package de.pincservices.template;

import org.junit.Ignore;
import org.junit.Test;

import java.util.Collections;

import static org.hamcrest.core.Is.is;
import static org.junit.Assert.assertThat;


public class VelocityTemplateEngineTest {
    private static final String TEMPLATE_LOCATION = "src/test/resources/templates";

    @Test
    public void testInitConfigurationWithoutFunctions() throws Exception {
        VelocityTemplateEngine engine = new VelocityTemplateEngine(TEMPLATE_LOCATION);
        // Assume that no exception will be thrown.
        engine.initConfiguration(null);
    }

    @Test
    public void testConfigurationWithFunctions() throws Exception {
        VelocityTemplateEngine engine = new VelocityTemplateEngine(TEMPLATE_LOCATION);
        TemplateDirective function = new EmailPrefixVelocityTemplateDirective();
        // Assume that no exception will be thrown.
        engine.initConfiguration(Collections.singletonList(function));
    }

    @Ignore("Cannot be tested because test directive is not recognizable by the engine, while it lays in test folder.")
    @Test
    public void testReplacement() throws Exception {
        VelocityTemplateEngine engine = new VelocityTemplateEngine(TEMPLATE_LOCATION);
        TemplateDirective function = new EmailPrefixVelocityTemplateDirective();
        // Assume that no exception will be thrown.
        engine.initConfiguration(Collections.singletonList(function));
        final String result1 = engine.replacePlaceholdersInText("my #emailPrefix(\"porscha@pincservices.de\")", null);
        assertThat(result1, is("my email: porscha@pincservices.de"));
    }
}
